
#include <menuet/os.h>

#define PF_INET 2
#define SOCK_STREAM	1		/* stream (connection) socket	*/


struct sockaddr {
  sa_family_t sa_family;
  char sa_data[14];
};


short int htons(short int i)
{
    return ((i>>8)&0xff)+((i << 8)&0xff00);
}

typedef unsigned short int in_port_t;
typedef unsigned int in_addr_t;

struct in_addr {
  in_addr_t s_addr;
};


/* Structure describing an Internet (IP) socket address. */
#define __SOCK_SIZE__	16		/* sizeof(struct sockaddr)	*/
struct sockaddr_in {
  sa_family_t		sin_family;	/* Address family		*/
  in_port_t		sin_port;	/* Port number			*/
  struct in_addr	sin_addr;	/* Internet address		*/
  /* Pad to size of `struct sockaddr'. */
  unsigned char		sin_zero[__SOCK_SIZE__ - sizeof(short int) -
			sizeof(unsigned short int) - sizeof(struct in_addr)];
};

int static inline open_socket(int domain, int type, int protocol)
{

int socket;

 __asm__("int $0x40":"=a"(socket):"a"(75),
  "b"(0),"c"(domain),"d"(type),"S"(protocol));

 return socket;
}

int static inline close_socket(int socket)
{
int err;
 __asm__("int $0x40":"=a"(err):"a"(75),
  "b"(1),"c"(socket));

 return err;
}


int static inline connect_socket(int socket, struct sockaddr * servaddr,  int len)
{
int err;
 __asm__("int $0x40":"=a"(err):"a"(75),
  "b"(4),"c"(socket),"d"(servaddr),"S"(len));


 return err;
}

int static inline send_socket(int socket, char *buffer,  int len, int flags)
{
int err;
 __asm__("int $0x40":"=a"(err):"a"(75),
  "b"(6),"c"(socket),"d"(buffer),"S"(len),"D"(flags));


 return err;
}

int static inline receive_socket(int socket, char *buffer,  int len, int flags)
{
int err;
 __asm__("int $0x40":"=a"(err):"a"(75),
  "b"(7),"c"(socket),"d"(buffer),"S"(len),"D"(flags));


 return err;
}




int static inline free_simple(int local)
{

int port;

 __asm__("int $0x40":"=a"(port):"a"(53),
  "b"(9),"c"(local));

 return port;
}


int static inline close_simple(int socket)
{

int port;

 __asm__("int $0x40":"=a"(port):"a"(53),
  "b"(8),"c"(socket));

 return port;
}


int static inline open_simple(int local, int global, int ip, int mode)
{
//mode 1=active
int socket;

 __asm__("int $0x40":"=a"(socket):"a"(53),
  "b"(5),"c"(local),"d"(global),"S"(ip), "D"(mode));

 return socket;
}

int static inline send_simple(int sock, void *buffer,  int count)
{
/*
 int __ret;
 __asm__("int $0x40":"=a"(__ret):"a"(53),"b"(7),
  "c"(sock),"d"(count),"S"((__u32)buffer));
 */
 
 int __ret;
 
 __ret = __menuet__write_TCP_socket(sock, count, buffer);
 
 if (__ret==0) { return count;}
 
 return 0;

}

int static inline recv_simple(int socket, char *buffer,  int len)
{

int err;

 __asm__("int $0x40":"=a"(err):"a"(53),
  "b"(11),"c"(socket),"d"(buffer),"S"(len));

 return err;
}

int static inline stat_simple(int socket)
{

int err;

 __asm__("int $0x40":"=a"(err):"a"(53),
  "b"(6),"c"(socket));

 return err;
}
