/*
   rdesktop: A Remote Desktop Protocol client.
   Protocol services - TCP layer
   Copyright (C) Matthew Chapman 1999-2001
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include <unistd.h>		/* select read write close */
//#include <sys/socket.h>		/* socket connect setsockopt */
//#include <sys/time.h>		/* timeval */
//#include <netdb.h>		/* gethostbyname */
//#include <netinet/in.h>		/* sockaddr_in */
//#include <netinet/tcp.h>	/* TCP_NODELAY */
//#include <arpa/inet.h>		/* inet_addr */
#include <errno.h>		/* errno */
#include "rdesktop.h"

#include "kolibri.c"

//WHAT IS SELECT??!

static int sock;
static struct stream in;
static struct stream out;

/* Initialise TCP transport data packet */
STREAM
tcp_init(int maxlen)
{
	if (maxlen > out.size)
	{
		out.data = xrealloc(out.data, maxlen);
		out.size = maxlen;
	}

	out.p = out.data;
	out.end = out.data + out.size;
	return &out;
}

/* Send TCP transport data packet */
void
tcp_send(STREAM s)
{
	int length = s->end - s->data;
	int sent, total = 0;

	__menuet__debug_out("\nRDP: SEND\n");

	while (total < length)
	{
		#ifndef OLD
		sent = send_socket(sock, s->data + total, length - total, 0);
		#else
		sent = send_simple(sock, s->data + total, length - total);
		#endif
		
		if (sent <= 0)
		{ 
		    __menuet__debug_out("\nRDP: SEND fail\n");
			error("send: %s\n", strerror(errno));
			return;
		}

		total += sent;
	}
	__menuet__debug_out("\nRDP: SEND done\n");
}

/* Receive a message on the TCP layer */
STREAM
tcp_recv(int length)
{
	int rcvd = 0;

	__menuet__debug_out("\nRDP: RECV\n");

	if (length > in.size)
	{
		in.data = xrealloc(in.data, length);
		in.size = length;
	}

	__menuet__debug_out("\nRDP: RECV xrealloc done\n");

	in.end = in.p = in.data;

	while (length > 0)
	{
	    __menuet__debug_out("\nRDP: UI_SELECT?\n");
		ui_select(sock);
		__menuet__debug_out("\nRDP: UI_SELECT!\n");

		#ifndef OLD
		rcvd = receive_socket(sock, in.end, length, 0);
		#else
		
		rcvd = recv_simple(sock, in.end, length);
		#endif
		
		
		if (rcvd == -1)
		{
			__menuet__debug_out("\nRECV failed, try again \n");
			//error("recv: %s\n", strerror(errno));
			return NULL;
			//just no data
		}

		in.end += rcvd;
		length -= rcvd;
	}

		__menuet__debug_out("\nRDP: RECV done\n");
	return &in;
}

/* Establish a connection on the TCP layer */
BOOL
tcp_connect(char *server)
{
//	struct hostent *nslookup;
	struct sockaddr_in servaddr;
//	int true = 1;

//	if (0) //((nslookup = gethostbyname(server)) != NULL)
//	{
//		memcpy(&servaddr.sin_addr, nslookup->h_addr,
//		       sizeof(servaddr.sin_addr));
//	}
//	else if (1) //(!(servaddr.sin_addr.s_addr = inet_addr(server)))
//	{
//		error("%s: unable to resolve host\n", server);
		#ifndef OLD
		sock=open_socket(PF_INET, SOCK_STREAM, 0);
		char deb[64];
		
		sprintf(deb,"Got socket: %d\n",sock);
		__menuet__debug_out(deb);
		


		//servaddr.sin_addr.s_addr = 0x0202000A;
		 
		 servaddr.sin_addr.s_addr = 0x2692A551;
		 
		servaddr.sin_family = 2;
	    servaddr.sin_port = htons(TCP_PORT_RDP); 
		   
		sprintf(deb,"Family: %x Port:%x Address:%x IP:%x\n",servaddr.sin_family , servaddr.sin_port, servaddr.sin_addr, servaddr.sin_addr.s_addr);
		__menuet__debug_out(deb);   
		
		   
		int test;      
		test=connect_socket(sock, (struct sockaddr *) &servaddr,
	     sizeof(struct sockaddr_in));
				
		sprintf(deb,"Connect socket: %d Port:%d\n",test, htons(80));
		__menuet__debug_out(deb);
		#else
		
		int port=1000;
		
		while (!free_simple(port)) {port+=10;}
		
		char dub[64];
		
		
		//servaddr.sin_addr.s_addr = 0x2692A551; hidnplayr
		
		//192.168.104.111 yogev
		

		//0x6F68A8C0
		//TCP_PORT_RDP
		sock=open_simple(port, TCP_PORT_RDP, 0x6F68A8C0, 1);
		sprintf (dub, "Port: %d Sock:%d\n", port, sock);
		__menuet__debug_out(dub);
		
		if (sock==-1) do {
			port++;
			while (!free_simple(port)) {port+=10;}
		
		char dub[64];
		
		
		sock=open_simple(port, TCP_PORT_RDP, 0x6F68A8C0, 1);
		sprintf (dub, "Port: %d Sock:%d\n", port, sock);
		__menuet__debug_out(dub); 
		} while (sock==-1);
		
		
		int conn, prev;
		prev=0;
		do {
		conn=stat_simple(sock);
		if (conn!=prev) {
		sprintf (dub, "Stat: %d Sock:%d\n", conn, sock);
		__menuet__debug_out(dub); 
		prev=conn;
		}}
		while (conn!=4);
		
		
		#endif
		
		return True;
//	}

/*
	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		error("socket: %s\n", strerror(errno));
		return False;
	}

	servaddr.sin_family = AF_INET;
	servaddr.sin_port = htons(TCP_PORT_RDP);

	if (connect
	    (sock, (struct sockaddr *) &servaddr,
	     sizeof(struct sockaddr)) < 0)
	{
		error("connect: %s\n", strerror(errno));
		close(sock);
		return False;
	}

	setsockopt(sock, IPPROTO_TCP, TCP_NODELAY, (void *) &true,
		   sizeof(true));

	in.size = 4096;
	in.data = xmalloc(in.size);

	out.size = 4096;
	out.data = xmalloc(out.size);

	return True;
	*/
	return False;
}

/* Disconnect on the TCP layer */
void
tcp_disconnect()
{
	//close(sock);
	
	#ifndef OLD
	char deb[64];
		   
	int test;   
	test=close_socket(sock);
				
	sprintf(deb,"Close socket: %d \n",test);
	__menuet__debug_out(deb);
	#else
	close_simple(sock);
	
	#endif
		
}
